//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3FCBB98F01E4.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3FCBB98F01E4.cm

//## begin module%3FCBB98F01E4.cp preserve=no
//## end module%3FCBB98F01E4.cp

//## Module: PsfImage%3FCBB98F01E4; Package specification
//## Subsystem: XSModel::Model::MixFunction%3F74624902C0
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSModel/Model/MixFunction/PsfImage.h

#ifndef PSFIMAGE_H
#define PSFIMAGE_H 1

//## begin module%3FCBB98F01E4.additionalIncludes preserve=no
//## end module%3FCBB98F01E4.additionalIncludes

//## begin module%3FCBB98F01E4.includes preserve=yes
#include "xsTypes.h"
#include <XSUtil/Utils/XSutility.h>
//## end module%3FCBB98F01E4.includes

// Error
#include <XSUtil/Error/Error.h>
//## begin module%3FCBB98F01E4.declarations preserve=no
//## end module%3FCBB98F01E4.declarations

//## begin module%3FCBB98F01E4.additionalDeclarations preserve=yes
//## end module%3FCBB98F01E4.additionalDeclarations


//## begin PsfImage%3FCBBAC7022E.preface preserve=yes
//## end PsfImage%3FCBBAC7022E.preface

//## Class: PsfImage%3FCBBAC7022E
//## Category: XSModel::Model::MixFunction%3F7461FF026E
//## Subsystem: XSModel::Model::MixFunction%3F74624902C0
//## Persistence: Transient
//## Cardinality/Multiplicity: n



class PsfImage 
{
  //## begin PsfImage%3FCBBAC7022E.initialDeclarations preserve=yes
  //## end PsfImage%3FCBBAC7022E.initialDeclarations

  public:
    //## Class: PsfImageError%3FCBBE4100C5
    //## Category: XSModel::Model::MixFunction%3F7461FF026E
    //## Subsystem: XSModel::Model::MixFunction%3F74624902C0
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    class PsfImageError : public YellowAlert  //## Inherits: <unnamed>%3FCBBE6101AE
    {
      public:
        //## Constructors (specified)
          //## Operation: PsfImageError%3FCBBF7500F6
          PsfImageError (const string& msg);

      protected:
      private:
      private: //## implementation
    };

    //## Constructors (specified)
      //## Operation: PsfImage%3FCBBB2A03A0
      PsfImage (const string& fileName);

    //## Destructor (generated)
      ~PsfImage();


    //## Other Operations (specified)
      //## Operation: calcPsf%3FCBBBA500FC
      void calcPsf (Real E, Real theta, Real phi, RealArray& psf);

      //## Operation: NDIM%4047A9E000D6
      static size_t NDIM ();

  public:
    // Additional Public Declarations
      //## begin PsfImage%3FCBBAC7022E.public preserve=yes
      //## end PsfImage%3FCBBAC7022E.public

  protected:
    // Additional Protected Declarations
      //## begin PsfImage%3FCBBAC7022E.protected preserve=yes
      //## end PsfImage%3FCBBAC7022E.protected

  private:

    //## Other Operations (specified)
      //## Operation: readImage%3FCBBBF403D1
      void readImage ();

      //## Operation: initGoodArray%3FCBBC0B0286
      void initGoodArray ();

      //## Operation: rotSym%3FCBBC200252
      static void rotSym (size_t i, size_t j, int irot, bool asym, size_t& ii, size_t& jj);

      //## Operation: getEnergyBracket%3FCBBC9901D9
      static void getEnergyBracket (Real E, size_t& ie0, size_t& ie1, Real& fe);

    // Additional Private Declarations
      //## begin PsfImage%3FCBBAC7022E.private preserve=yes
      //## end PsfImage%3FCBBAC7022E.private

  private: //## implementation
    // Data Members for Class Attributes

      //## Attribute: fileName%3FCBBD3A01F5
      //## begin PsfImage::fileName%3FCBBD3A01F5.attr preserve=no  private: string {U} 
      string m_fileName;
      //## end PsfImage::fileName%3FCBBD3A01F5.attr

      //## Attribute: NDIM%3FCBBD650214
      //## begin PsfImage::NDIM%3FCBBD650214.attr preserve=no  public: static const size_t {U} 63
      static const size_t s_NDIM;
      //## end PsfImage::NDIM%3FCBBD650214.attr

      //## Attribute: NP%3FCBBD9D029C
      //## begin PsfImage::NP%3FCBBD9D029C.attr preserve=no  private: static const size_t {U} 13
      static const size_t s_NP;
      //## end PsfImage::NP%3FCBBD9D029C.attr

      //## Attribute: pGood%3FCBBDF5015C
      //## begin PsfImage::pGood%3FCBBDF5015C.attr preserve=no  private: XSutility::auto_array_ptr<bool> {U} 
      XSutility::auto_array_ptr<bool> m_pGood;
      //## end PsfImage::pGood%3FCBBDF5015C.attr

      //## Attribute: pAllPsf%40754AE7031E
      //## begin PsfImage::pAllPsf%40754AE7031E.attr preserve=no  private: XSutility::auto_array_ptr<Real> {U} 
      XSutility::auto_array_ptr<Real> m_pAllPsf;
      //## end PsfImage::pAllPsf%40754AE7031E.attr

    // Additional Implementation Declarations
      //## begin PsfImage%3FCBBAC7022E.implementation preserve=yes
      static const Real s_energy[];
      static const size_t s_NE;
      static const Real s_thetas[];
      static const size_t s_nThetas;
      static const size_t s_nPhisMax;
      static const size_t s_nPhis[];
      static const Real s_phis[];
      static const size_t s_nPoint[];
      static const int s_iDetCent[];
      
      //## end PsfImage%3FCBBAC7022E.implementation
};

//## begin PsfImage%3FCBBAC7022E.postscript preserve=yes
//## end PsfImage%3FCBBAC7022E.postscript

// Class PsfImage::PsfImageError 

// Class PsfImage 

//## begin module%3FCBB98F01E4.epilog preserve=yes
//## end module%3FCBB98F01E4.epilog


#endif
